Index: trunk/src/VBox/Additions/common/VBoxGuestLib/HGCM.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuestLib/HGCM.cpp	(revision 300)
+++ trunk/src/VBox/Additions/common/VBoxGuestLib/HGCM.cpp	(revision 301)
@@ -72,5 +72,5 @@
 }
 
-DECLINLINE(int) vbglHandleHeapEnter (void)
+static DECLINLINE(int) vbglHandleHeapEnter (void)
 {
     int rc = RTSemFastMutexRequest(g_vbgldata.mutexHGCMHandle);
@@ -82,5 +82,5 @@
 }
 
-DECLINLINE(void) vbglHandleHeapLeave (void)
+static DECLINLINE(void) vbglHandleHeapLeave (void)
 {
     RTSemFastMutexRelease(g_vbgldata.mutexHGCMHandle);
Index: trunk/src/VBox/Additions/linux/Makefile
===================================================================
--- trunk/src/VBox/Additions/linux/Makefile	(revision 300)
+++ trunk/src/VBox/Additions/linux/Makefile	(revision 301)
@@ -55,4 +55,5 @@
 		installer/vboxadd.sh \
 		installer/install.sh \
+		../../Installer/linux/routines.sh \
 		../../Installer/linux/runlevel.sh \
 		installer/x11config.pl \
@@ -82,4 +83,5 @@
 	$(QUIET)$(INSTALL) -m 0755 installer/vboxadd-timesync.sh $(PATH_TARGET)/install
 	$(QUIET)$(INSTALL) -m 0755 installer/vboxadd.sh   $(PATH_TARGET)/install
+	$(QUIET)$(INSTALL) -m 0755 ../../Installer/linux/routines.sh  $(PATH_TARGET)/install
 	$(QUIET)$(INSTALL) -m 0755 ../../Installer/linux/runlevel.sh  $(PATH_TARGET)/install
 	$(QUIET)$(INSTALL) -m 0755 installer/x11config.pl $(PATH_TARGET)/install
Index: trunk/src/VBox/Additions/linux/installer/vboxadd-timesync.sh
===================================================================
--- trunk/src/VBox/Additions/linux/installer/vboxadd-timesync.sh	(revision 300)
+++ trunk/src/VBox/Additions/linux/installer/vboxadd-timesync.sh	(revision 301)
@@ -1,3 +1,3 @@
-#!/bin/bash
+#!/bin/sh
 #
 #  InnoTek VirtualBox
@@ -32,9 +32,5 @@
 ### END INIT INFO
 
-# We still have some dependency problems to solve
-#if [ ! "`uname -r | grep '2.4'`" = "" ]; then
-#    echo The VirtualBox time synchronization module currently does not work on 2.4 series Linux kernels
-#    exit 0
-#fi
+PATH=$PATH:/bin:/sbin:/usr/sbin
 
 system=unknown
@@ -51,9 +47,11 @@
     system=gentoo
     PIDFILE="/var/run/vboxadd-timesync"
+elif [ -f /etc/slackware-version ]; then
+    system=slackware
 else
     echo "$0: Unknown system" 1>&2
 fi
 
-if [ $system = redhat ]; then
+if [ "$system" = redhat ]; then
     . /etc/init.d/functions
     fail_msg() {
@@ -68,5 +66,5 @@
 fi
 
-if [ $system = suse ]; then
+if [ "$system" = suse ]; then
     . /etc/rc.status
     daemon() {
@@ -85,5 +83,5 @@
 fi
 
-if [ $system = debian ]; then
+if [ "$system" = debian ]; then
     daemon() {
         start-stop-daemon --start --exec $1 -- $2
@@ -103,5 +101,5 @@
 fi
 
-if [ $system = gentoo ]; then
+if [ "$system" = gentoo ]; then
     . /sbin/functions.sh
     daemon() {
@@ -126,7 +124,21 @@
 fi
 
+if [ "$system" = slackware ]; then
+    fail_msg() {
+        echo "...fail!"
+    }
+
+    succ_msg() {
+        echo "...done."
+    }
+
+    begin() {
+        echo -n $1
+    }
+fi
+
 binary=/usr/sbin/vboxadd-timesync
 
-test -x $binary || {
+test -x "$binary" || {
     echo "Cannot run $binary"
     exit 1
Index: trunk/src/VBox/Additions/linux/installer/vboxadd.sh
===================================================================
--- trunk/src/VBox/Additions/linux/installer/vboxadd.sh	(revision 300)
+++ trunk/src/VBox/Additions/linux/installer/vboxadd.sh	(revision 301)
@@ -1,3 +1,3 @@
-#! /bin/bash
+#! /bin/sh
 # InnoTek VirtualBox
 # Linux Additions kernel module init script
@@ -29,4 +29,6 @@
 # Description:    VirtualBox Linux Additions kernel module
 ### END INIT INFO
+
+PATH=$PATH:/bin:/sbin:/usr/sbin
 
 system=unknown
@@ -39,9 +41,11 @@
 elif [ -f /etc/gentoo-release ]; then
     system=gentoo
+elif [ -f /etc/slackware-version ]; then
+    system=slackware
 else
     echo "$0: Unknown system" 1>&2
 fi
 
-if [ $system = redhat ]; then
+if [ "$system" = "redhat" ]; then
     . /etc/init.d/functions
     fail_msg() {
@@ -60,5 +64,5 @@
 fi
 
-if [ $system = suse ]; then
+if [ "$system" = "suse" ]; then
     . /etc/rc.status
     fail_msg() {
@@ -77,5 +81,5 @@
 fi
 
-if [ $system = debian ]; then
+if [ "$system" = "debian" ]; then
     fail_msg() {
         echo "...fail!"
@@ -91,5 +95,5 @@
 fi
 
-if [ $system = gentoo ]; then
+if [ "$system" = "gentoo" ]; then
     . /sbin/functions.sh
     fail_msg() {
@@ -110,4 +114,18 @@
 fi
 
+if [ "$system" = "slackware" ]; then
+    fail_msg() {
+        echo "...fail!"
+    }
+
+    succ_msg() {
+        echo "...done."
+    }
+
+    begin() {
+        echo -n $1
+    }
+fi
+                                                
 kdir=/lib/modules/`uname -r`/misc
 dev=/dev/vboxadd
@@ -120,5 +138,5 @@
 
 fail() {
-    if [ $system = gentoo ]; then
+    if [ "$system" = "gentoo" ]; then
         eerror $1
         exit 1
@@ -152,5 +170,5 @@
     if [ ! -c $dev ]; then
         maj=`sed -n 's;\([0-9]\+\) vboxadd;\1;p' /proc/devices`
-        test -z $maj && {
+        test -z "$maj" && {
             rmmod $modname
             fail "Cannot locate device major"
Index: trunk/src/VBox/Additions/linux/installer/vboxvfs.sh
===================================================================
--- trunk/src/VBox/Additions/linux/installer/vboxvfs.sh	(revision 300)
+++ trunk/src/VBox/Additions/linux/installer/vboxvfs.sh	(revision 301)
@@ -1,3 +1,3 @@
-#! /bin/bash
+#! /bin/sh
 # InnoTek VirtualBox
 # Linux Additions VFS kernel module init script
@@ -29,4 +29,6 @@
 # Description:    VirtualBox Linux Additions VFS kernel module
 ### END INIT INFO
+
+PATH=$PATH:/bin:/sbin:/usr/sbin
 
 system=unknown
@@ -39,9 +41,11 @@
 elif [ -f /etc/gentoo-release ]; then
     system=gentoo
+elif [ -f /etc/slackware-version ]; then
+    system=slackware
 else
     echo "$0: Unknown system" 1>&2
 fi
 
-if [ $system = redhat ]; then
+if [ "$system" = redhat ]; then
     . /etc/init.d/functions
     fail_msg() {
@@ -60,5 +64,5 @@
 fi
 
-if [ $system = suse ]; then
+if [ "$system" = suse ]; then
     . /etc/rc.status
     fail_msg() {
@@ -77,5 +81,5 @@
 fi
 
-if [ $system = debian ]; then
+if [ "$system" = debian ]; then
     fail_msg() {
         echo "...fail!"
@@ -91,5 +95,5 @@
 fi
 
-if [ $system = gentoo ]; then
+if [ "$system" = gentoo ]; then
     . /sbin/functions.sh
     fail_msg() {
@@ -110,7 +114,21 @@
 fi
 
+if [ "$system" = slackware ]; then
+    fail_msg() {
+        echo "...fail!"
+    }
+
+    succ_msg() {
+        echo "...done."
+    }
+
+    begin() {
+        echo -n $1
+    }
+fi
+
 kdir=/lib/modules/`uname -r`/misc
 modname=vboxvfs
-module=$kdir/$modname
+module="$kdir/$modname"
 
 file=""
@@ -119,5 +137,5 @@
 
 fail() {
-    if [ $system = gentoo ]; then
+    if [ "$system" = gentoo ]; then
         eerror $1
         exit 1