Index: trunk/src/VBox/Frontends/VirtualBox/Makefile
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/Makefile	(revision 369)
+++ trunk/src/VBox/Frontends/VirtualBox/Makefile	(revision 370)
@@ -314,5 +314,5 @@
 # static images are imported from VBoxUI.pro as IMAGES
 
-$(PATH_VirtualBox)/ui/vbox_image_collection.txt: Makefile $(IMAGES)
+$(PATH_VirtualBox)/ui/vbox_image_collection.txt: Makefile VBoxUI.pro $(IMAGES)
 	@echo " \
 	$(IMAGES) \
Index: trunk/src/VBox/Frontends/VirtualBox/VBoxUI.pro
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/VBoxUI.pro	(revision 369)
+++ trunk/src/VBox/Frontends/VirtualBox/VBoxUI.pro	(revision 370)
@@ -113,4 +113,5 @@
 	images/ico40x01.png \
 	images/ico64x01.png \
+	images/help_16px.png \
 	images/about_16px.png \
 	images/site_16px.png \
@@ -120,4 +121,10 @@
 	images/fullscreen_16px.png \
 	images/fullscreen_disabled_16px.png \
+	images/acpi_16px.png \
+	images/acpi_disabled_16px.png \
+	images/adjust_win_size_16px.png \
+	images/adjust_win_size_disabled_16px.png \
+	images/auto_resize_16px.png \
+	images/auto_resize_disabled_16px.png \
 	images/exit_16px.png \
 	images/fd_unmount_16px.png \
@@ -174,3 +181,23 @@
 	images/show_snapshot_details_dis_16px.png \
 	images/show_snapshot_details_dis_22px.png \
+	images/refresh_16px.png \
+	images/refresh_disabled_16px.png \
+	images/refresh_22px.png \
+	images/refresh_disabled_22px.png \
+	images/vdm_add_16px.png \
+	images/vdm_add_disabled_16px.png \
+	images/vdm_add_22px.png \
+	images/vdm_add_disabled_22px.png \
+	images/vdm_new_16px.png \
+	images/vdm_new_disabled_16px.png \
+	images/vdm_new_22px.png \
+	images/vdm_new_disabled_22px.png \
+	images/vdm_release_16px.png \
+	images/vdm_release_disabled_16px.png \
+	images/vdm_release_22px.png \
+	images/vdm_release_disabled_22px.png \
+	images/vdm_remove_16px.png \
+	images/vdm_remove_disabled_16px.png \
+	images/vdm_remove_22px.png \
+	images/vdm_remove_disabled_22px.png \
 	images/about_600px.png
Index: trunk/src/VBox/Frontends/VirtualBox/src/VBoxConsoleWnd.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/VBoxConsoleWnd.cpp	(revision 369)
+++ trunk/src/VBox/Frontends/VirtualBox/src/VBoxConsoleWnd.cpp	(revision 370)
@@ -182,10 +182,11 @@
     vmAutoresizeGuestAction = new QAction (runningActions, "vmAutoresizeGuestAction");
     vmAutoresizeGuestAction->setIconSet (
-        VBoxGlobal::iconSet ("fullscreen_16px.png", "fullscreen_disabled_16px.png"));
+        VBoxGlobal::iconSet ("auto_resize_16px.png", "auto_resize_disabled_16px.png"));
     vmAutoresizeGuestAction->setToggleAction (true);
 
     vmAdjustWindowAction = new QAction (this, "vmAdjustWindowAction");
     vmAdjustWindowAction->setIconSet (
-        VBoxGlobal::iconSet ("fullscreen_16px.png", "fullscreen_disabled_16px.png"));
+        VBoxGlobal::iconSet ("adjust_win_size_16px.png",
+                             "adjust_win_size_disabled_16px.png"));
 
     vmTypeCADAction = new QAction (runningActions, "vmTypeCADAction");
@@ -208,4 +209,6 @@
 
     vmACPIShutdownAction = new QAction (this, "vmACPIShutdownAction");
+    vmACPIShutdownAction->setIconSet (
+        VBoxGlobal::iconSet ("acpi_16px.png", "acpi_disabled_16px.png"));
 
     vmCloseAction = new QAction (this, "vmCloseAction");
Index: trunk/src/VBox/Frontends/VirtualBox/src/VBoxSelectorWnd.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/VBoxSelectorWnd.cpp	(revision 369)
+++ trunk/src/VBox/Frontends/VirtualBox/src/VBoxSelectorWnd.cpp	(revision 370)
@@ -256,5 +256,5 @@
     
     helpContentsAction = new QAction (this, "helpContentsAction");
-    helpContentsAction->setIconSet (VBoxGlobal::iconSet ("about_16px.png"));
+    helpContentsAction->setIconSet (VBoxGlobal::iconSet ("help_16px.png"));
     helpWebAction = new QAction (this, "helpWebAction");
     helpWebAction->setIconSet (VBoxGlobal::iconSet ("site_16px.png"));
Index: trunk/src/VBox/Frontends/VirtualBox/ui/VBoxDiskImageManagerDlg.ui.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/ui/VBoxDiskImageManagerDlg.ui.h	(revision 369)
+++ trunk/src/VBox/Frontends/VirtualBox/ui/VBoxDiskImageManagerDlg.ui.h	(revision 370)
@@ -322,10 +322,20 @@
     imRefreshAction->setStatusTip (tr ("Refresh media image list"));
 
-    imNewAction->setIconSet (VBoxGlobal::iconSet ("hd_16px.png", "hd_disabled_16px.png"));
-    imAddAction->setIconSet (VBoxGlobal::iconSet ("cd_16px.png", "cd_disabled_16px.png"));
+    imNewAction->setIconSet (VBoxGlobal::iconSetEx (
+        "vdm_new_22px.png", "vdm_new_16px.png",
+        "vdm_new_disabled_22px.png", "vdm_new_disabled_16px.png"));
+    imAddAction->setIconSet (VBoxGlobal::iconSetEx (
+        "vdm_add_22px.png", "vdm_add_16px.png",
+        "vdm_add_disabled_22px.png", "vdm_add_disabled_16px.png"));
     // imEditAction->setIconSet (VBoxGlobal::iconSet ("guesttools_16px.png", "guesttools_disabled_16px.png"));
-    imRemoveAction->setIconSet (VBoxGlobal::iconSet ("delete_16px.png", "delete_dis_16px.png"));
-    imReleaseAction->setIconSet (VBoxGlobal::iconSet ("start_16px.png", "start_dis_16px.png"));
-    imRefreshAction->setIconSet (VBoxGlobal::iconSet ("settings_16px.png", "settings_dis_16px.png"));
+    imRemoveAction->setIconSet (VBoxGlobal::iconSetEx (
+        "vdm_remove_22px.png", "vdm_remove_16px.png",
+        "vdm_remove_disabled_22px.png", "vdm_remove_disabled_16px.png"));
+    imReleaseAction->setIconSet (VBoxGlobal::iconSetEx (
+        "vdm_release_22px.png", "vdm_release_16px.png",
+        "vdm_release_disabled_22px.png", "vdm_release_disabled_16px.png"));
+    imRefreshAction->setIconSet (VBoxGlobal::iconSetEx (
+        "refresh_22px.png", "refresh_16px.png",
+        "refresh_disabled_22px.png", "refresh_disabled_16px.png"));
 
     // imEditAction->addTo (itemMenu);
@@ -338,5 +348,7 @@
     toolBar->setSizePolicy (QSizePolicy::Fixed, QSizePolicy::Minimum);
     ((QVBoxLayout*)centralWidget()->layout())->insertWidget(0, toolBar);
-    setUsesTextLabel (true);
+
+    toolBar->setUsesTextLabel (true);
+    toolBar->setUsesBigPixmaps (true);
 
     imNewAction->addTo (toolBar);