Index: trunk/src/VBox/VMM/testcase/tstVMStructGC.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstVMStructGC.cpp	(revision 520)
+++ trunk/src/VBox/VMM/testcase/tstVMStructGC.cpp	(revision 527)
@@ -172,7 +172,55 @@
     GEN_CHECK_OFF(PDM, pCritSects);
     GEN_CHECK_OFF(PDM, aPciBuses);
+    GEN_CHECK_OFF(PDM, aPciBuses[0].iBus);
+    GEN_CHECK_OFF(PDM, aPciBuses[0].pDevInsR3);
+    GEN_CHECK_OFF(PDM, aPciBuses[0].pfnSetIrqR3);
+    GEN_CHECK_OFF(PDM, aPciBuses[0].pfnRegisterR3);
+    GEN_CHECK_OFF(PDM, aPciBuses[0].pfnIORegionRegisterR3);
+    GEN_CHECK_OFF(PDM, aPciBuses[0].pfnSaveExecR3);
+    GEN_CHECK_OFF(PDM, aPciBuses[0].pfnLoadExecR3);
+    GEN_CHECK_OFF(PDM, aPciBuses[0].pfnFakePCIBIOSR3);
+    GEN_CHECK_OFF(PDM, aPciBuses[0].pDevInsR0);
+    GEN_CHECK_OFF(PDM, aPciBuses[0].pfnSetIrqR0);
+    GEN_CHECK_OFF(PDM, aPciBuses[0].pDevInsGC);
+    GEN_CHECK_OFF(PDM, aPciBuses[0].pfnSetIrqGC);
     GEN_CHECK_OFF(PDM, Pic);
+    GEN_CHECK_OFF(PDM, Pic.pDevInsR3);
+    GEN_CHECK_OFF(PDM, Pic.pfnSetIrqR3);
+    GEN_CHECK_OFF(PDM, Pic.pfnGetInterruptR3);
+    GEN_CHECK_OFF(PDM, Pic.pDevInsR0);
+    GEN_CHECK_OFF(PDM, Pic.pfnSetIrqR0);
+    GEN_CHECK_OFF(PDM, Pic.pfnGetInterruptR0);
+    GEN_CHECK_OFF(PDM, Pic.pDevInsGC);
+    GEN_CHECK_OFF(PDM, Pic.pfnSetIrqGC);
+    GEN_CHECK_OFF(PDM, Pic.pfnGetInterruptGC);
     GEN_CHECK_OFF(PDM, Apic);
+    GEN_CHECK_OFF(PDM, Apic.pDevInsR3);
+    GEN_CHECK_OFF(PDM, Apic.pfnGetInterruptR3);
+    GEN_CHECK_OFF(PDM, Apic.pfnSetBaseR3);
+    GEN_CHECK_OFF(PDM, Apic.pfnGetBaseR3);
+    GEN_CHECK_OFF(PDM, Apic.pfnSetTPRR3);
+    GEN_CHECK_OFF(PDM, Apic.pfnGetTPRR3);
+    GEN_CHECK_OFF(PDM, Apic.pfnBusDeliverR3);
+    GEN_CHECK_OFF(PDM, Apic.pDevInsR0);
+    GEN_CHECK_OFF(PDM, Apic.pfnGetInterruptR0);
+    GEN_CHECK_OFF(PDM, Apic.pfnSetBaseR0);
+    GEN_CHECK_OFF(PDM, Apic.pfnGetBaseR0);
+    GEN_CHECK_OFF(PDM, Apic.pfnSetTPRR0);
+    GEN_CHECK_OFF(PDM, Apic.pfnGetTPRR0);
+    GEN_CHECK_OFF(PDM, Apic.pfnBusDeliverR0);
+    GEN_CHECK_OFF(PDM, Apic.pDevInsGC);
+    GEN_CHECK_OFF(PDM, Apic.pfnGetInterruptGC);
+    GEN_CHECK_OFF(PDM, Apic.pfnSetBaseGC);
+    GEN_CHECK_OFF(PDM, Apic.pfnGetBaseGC);
+    GEN_CHECK_OFF(PDM, Apic.pfnSetTPRGC);
+    GEN_CHECK_OFF(PDM, Apic.pfnGetTPRGC);
+    GEN_CHECK_OFF(PDM, Apic.pfnBusDeliverGC);
     GEN_CHECK_OFF(PDM, IoApic);
+    GEN_CHECK_OFF(PDM, IoApic.pDevInsR3);
+    GEN_CHECK_OFF(PDM, IoApic.pfnSetIrqR3);
+    GEN_CHECK_OFF(PDM, IoApic.pDevInsR0);
+    GEN_CHECK_OFF(PDM, IoApic.pfnSetIrqR0);
+    GEN_CHECK_OFF(PDM, IoApic.pDevInsGC);
+    GEN_CHECK_OFF(PDM, IoApic.pfnSetIrqGC);
     GEN_CHECK_OFF(PDM, pDmac);
     GEN_CHECK_OFF(PDM, pRtc);
@@ -193,7 +241,62 @@
 #endif
     GEN_CHECK_OFF(PDM, StatQueuedCritSectLeaves);
+    GEN_CHECK_SIZE(PDMDEVINSINT);
+    GEN_CHECK_OFF(PDMDEVINSINT, pNextHC);
+    GEN_CHECK_OFF(PDMDEVINSINT, pPerDeviceNextHC);
+    GEN_CHECK_OFF(PDMDEVINSINT, pDevHC);
+    GEN_CHECK_OFF(PDMDEVINSINT, pVMHC);
+    GEN_CHECK_OFF(PDMDEVINSINT, pVMGC);
+    GEN_CHECK_OFF(PDMDEVINSINT, pLunsHC);
+    GEN_CHECK_OFF(PDMDEVINSINT, pCfgHandle);
+    GEN_CHECK_OFF(PDMDEVINSINT, pPciDeviceHC);
+    GEN_CHECK_OFF(PDMDEVINSINT, pPciDeviceGC);
+    GEN_CHECK_OFF(PDMDEVINSINT, pPciBusHC);
+    GEN_CHECK_OFF(PDMDEVINSINT, pPciBusGC);
+    GEN_CHECK_SIZE(PDMCRITSECTINT);
+    GEN_CHECK_OFF(PDMCRITSECTINT, Core);
+    GEN_CHECK_OFF(PDMCRITSECTINT, pNext);
+    GEN_CHECK_OFF(PDMCRITSECTINT, pvKey);
+    GEN_CHECK_OFF(PDMCRITSECTINT, pVMR3);
+    GEN_CHECK_OFF(PDMCRITSECTINT, pVMR0);
+    GEN_CHECK_OFF(PDMCRITSECTINT, pVMGC);
+    GEN_CHECK_OFF(PDMCRITSECTINT, StatContentionR0GCLock);
+    GEN_CHECK_OFF(PDMCRITSECTINT, StatContentionR0GCUnlock);
+    GEN_CHECK_OFF(PDMCRITSECTINT, StatContentionR3);
+    GEN_CHECK_OFF(PDMCRITSECTINT, StatLocked);
+    GEN_CHECK_SIZE(PDMQUEUE);
+    GEN_CHECK_OFF(PDMQUEUE, pNext);
+    GEN_CHECK_OFF(PDMQUEUE, enmType);
+    GEN_CHECK_OFF(PDMQUEUE, u);
+    GEN_CHECK_OFF(PDMQUEUE, u.Dev.pfnCallback);
+    GEN_CHECK_OFF(PDMQUEUE, u.Dev.pDevIns);
+    GEN_CHECK_OFF(PDMQUEUE, u.Drv.pfnCallback);
+    GEN_CHECK_OFF(PDMQUEUE, u.Drv.pDrvIns);
+    GEN_CHECK_OFF(PDMQUEUE, u.Int.pfnCallback);
+    GEN_CHECK_OFF(PDMQUEUE, u.Ext.pfnCallback);
+    GEN_CHECK_OFF(PDMQUEUE, u.Ext.pvUser);
+    GEN_CHECK_OFF(PDMQUEUE, pVMHC);
+    GEN_CHECK_OFF(PDMQUEUE, pVMGC);
+    GEN_CHECK_OFF(PDMQUEUE, cMilliesInterval);
+    GEN_CHECK_OFF(PDMQUEUE, pTimer);
+    GEN_CHECK_OFF(PDMQUEUE, cbItem);
+    GEN_CHECK_OFF(PDMQUEUE, cItems);
+    GEN_CHECK_OFF(PDMQUEUE, pPendingHC);
+    GEN_CHECK_OFF(PDMQUEUE, pPendingGC);
+    GEN_CHECK_OFF(PDMQUEUE, iFreeHead);
+    GEN_CHECK_OFF(PDMQUEUE, iFreeTail);
+    GEN_CHECK_OFF(PDMQUEUE, aFreeItems);
+    GEN_CHECK_OFF(PDMQUEUE, aFreeItems[1]);
+    GEN_CHECK_OFF(PDMQUEUE, aFreeItems[0].pItemGC);
+    GEN_CHECK_OFF(PDMQUEUE, aFreeItems[1].pItemHC);
+    GEN_CHECK_SIZE(PDMDEVHLPTASK);
+    GEN_CHECK_OFF(PDMDEVHLPTASK, Core);
+    GEN_CHECK_OFF(PDMDEVHLPTASK, pDevInsHC);
+    GEN_CHECK_OFF(PDMDEVHLPTASK, enmOp);
+    GEN_CHECK_OFF(PDMDEVHLPTASK, u);
+    GEN_CHECK_OFF(PDMDEVHLPTASK, u.SetIRQ.iIrq);
+    GEN_CHECK_OFF(PDMDEVHLPTASK, u.SetIRQ.iLevel);
 
     GEN_CHECK_SIZE(PGM);
-    GEN_CHECK_OFF(PGM,  offVM);
+    GEN_CHECK_OFF(PGM, offVM);
     GEN_CHECK_OFF(PGM, paDynPageMap32BitPTEsGC);
     GEN_CHECK_OFF(PGM, paDynPageMapPaePTEsGC);